



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SpinnerViewPop【PopWindow样式（单选）、Dialog样式（单选+多选）的下拉菜单】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SpinnerViewPop【PopWindow样式（单选）、Dialog样式（单选+多选）的下拉菜单】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 12:46:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><em><em>版权声明：本文为</em><em>HaiyuKing</em><em>原创文章，转载请注明出处！</em></em></p>
<h2>前言</h2>
<p>对下拉菜单的文本区域和列表区域进行了封装。包括两种展现方式：popwindow（单选）、dialog（单选+多选）</p>
<p>因为该封装需要在Eclipse开发环境中使用，所以列表控件使用的是ListView。</p>
<h2>效果图</h2>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/93830/201806/93830-20180606160413158-1644325046.gif" /></p>
<h2>代码分析</h2>
<p><strong>SpinnerViewPop</strong>：自定义RelativeLayout子类【<strong>popwindow（单选）、dialog（单选）</strong>】</p>
<p><strong>SpinnerViewMultiDialog</strong>：自定义RelativeLayout子类【<strong>dialog（多选）</strong>】</p>
<p><strong>PopWindowUtil</strong>：PopWindow的封装【<strong>popwindow（单选）</strong>】</p>
<p><strong>DialogUtil</strong>：dialog的封装【<strong>dialog（单选+多选）</strong>】</p>
<p><strong>MySpinnerPopListArrayAdapter</strong>：列表适配器【<strong>popwindow（单选）、dialog（单选）</strong>】</p>
<p><strong>MySpinnerPopMultListArrayAdapter</strong>：列表适配器【<strong>dialog（多选）</strong>】</p>
<p><strong>常用的方法：</strong></p>
<ul><li>setEditable &mdash;&mdash; 设置下拉菜单区域是否可点击（可编辑）【参考Demo中的第1个】</li>
<li>setHint &mdash;&mdash; 设置下拉菜单区域的提示语【参考Demo中的多选对话框】</li>
<li>setSpinnerType &mdash;&mdash; 用于区分popwindow（单选）、dialog（单选）【参考Demo中的第4个】</li>
<li>setHandedPopup &mdash;&mdash;设置下拉菜单区域是否执行点击事件的状态值，搭配OnSpinnerClickListener使用，实现点击下拉菜单区域触发事件，一般用来隐藏软键盘，或者网络请求，最后手动弹出下拉菜单【参考Demo中的第2个】</li>
<li>setData &mdash;&mdash; 设置数据源集合【初始化数据的时候调用】</li>
<li>setSelectedIndexAndText &mdash;&mdash; 设置单选情况下的指定选中列表项【初始化数据的时候调用，设置默认值】</li>
<li>setOnSpinnerClickListener &mdash;&mdash; 下拉菜单区域的点击事件监听器{一般用来隐藏软键盘，或者网络请求，最后手动弹出下拉菜单}</li>
<li>setOnSpinnerItemClickListener &mdash;&mdash; 单选情况下的列表项的点击事件监听器</li>
<li>setOnSpinnerConfirmClickListener &mdash;&mdash; 多选情况下的确定操作的点击事件监听器</li></ul>
<h2>使用步骤</h2>
<h3>一、项目组织结构图</h3>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/93830/201806/93830-20180606152645275-637791928.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/93830/201806/93830-20180606153535971-299831229.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/93830/201806/93830-20180606153620659-287221198.png" /></p>
<p>注意事项：</p>
<p>1、导入类文件后需要change包名以及重新import R文件路径</p>
<p>2、 Values目录下的文件（strings.xml、dimens.xml、colors.xml等），如果项目中存在，则复制里面的内容，不要整个覆盖</p>
<h3>二、导入步骤</h3>
<h4>将drawable、drawable-xxhdpi目录下的文件复制到项目中</h4>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/93830/201707/93830-20170728173233071-1100014433.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/93830/201708/93830-20170821163652996-1481576393.png" /></p>
<h4>将布局文件复制到项目中</h4>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/93830/201708/93830-20170821163716058-180242532.png" /></p>
<h4>在colors.xml文件中添加以下代码</h4>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;resources&gt;<br />
    &lt;color name="colorPrimary"&gt;#3F51B5&lt;/color&gt;<br />
    &lt;color name="colorPrimaryDark"&gt;#303F9F&lt;/color&gt;<br />
    &lt;color name="colorAccent"&gt;#FF4081&lt;/color&gt;

    &lt;!-- *********************popwindow样式下拉菜单************************* --&gt;<br />
    &lt;!-- popwindow样式下拉菜单文本选中状态的颜色 --&gt;<br />
    &lt;color name="spinnerpop_selected_text_color"&gt;#0365C5&lt;/color&gt;<br />
    &lt;!-- popwindow样式下拉菜单文本默认状态的颜色 --&gt;<br />
    &lt;color name="spinnerpop_normal_text_color"&gt;#191919&lt;/color&gt;<br />
    &lt;!-- popwindow样式下拉菜单可编辑的背景颜色 --&gt;<br />
    &lt;color name="spinnerpop_canedit_bg_color"&gt;#ffffff&lt;/color&gt;<br />
    &lt;!-- popwindow样式下拉菜单不可编辑的背景颜色 --&gt;<br />
    &lt;color name="spinnerpop_notedit_bg_color"&gt;#C5C5C5&lt;/color&gt;

&lt;/resources&gt;</pre>
</div>
<h4>在dimens.xml中添加以下代码</h4>
<div>
<pre class="prettyprint linenums">&lt;resources&gt;<br />
    &lt;!-- Default screen margins, per the Android Design guidelines. --&gt;<br />
    &lt;dimen name="activity_horizontal_margin"&gt;16dp&lt;/dimen&gt;<br />
    &lt;dimen name="activity_vertical_margin"&gt;16dp&lt;/dimen&gt;

    &lt;!-- *********************popwindow样式下拉菜单************************* --&gt;<br />
    &lt;!-- 下拉菜单文本大小 --&gt;<br />
    &lt;dimen name="spinnerpop_text_size"&gt;18sp&lt;/dimen&gt;<br />
    &lt;!-- 下拉菜单列表项的文本大小 --&gt;<br />
    &lt;dimen name="spinnerpop_listitem_text_size"&gt;18sp&lt;/dimen&gt;<br />
    &lt;!-- 下拉菜单列表项的内边距 --&gt;<br />
    &lt;dimen name="spinnerpop_listitem_padding"&gt;10dp&lt;/dimen&gt;<br />
    &lt;!-- 下拉菜单高度 --&gt;<br />
    &lt;dimen name="spinnerpop_height"&gt;42dp&lt;/dimen&gt;<br />
    &lt;!-- 下拉菜单按钮的外边距 --&gt;<br />
    &lt;dimen name="spinnerpop_confirm_margin"&gt;15dp&lt;/dimen&gt;

&lt;/resources&gt;</pre>
</div>
<h4>在styles.xml文件中添加以下代码</h4>
<div>
<pre class="prettyprint linenums">&lt;resources&gt;

    &lt;!-- Base application theme. --&gt;<br />
    &lt;style name="AppTheme" parent="Theme.AppCompat.Light.DarkActionBar"&gt;<br />
        &lt;!-- Customize your theme here. --&gt;<br />
        &lt;item name="colorPrimary"&gt;@color/colorPrimary&lt;/item&gt;<br />
        &lt;item name="colorPrimaryDark"&gt;@color/colorPrimaryDark&lt;/item&gt;<br />
        &lt;item name="colorAccent"&gt;@color/colorAccent&lt;/item&gt;<br />
    &lt;/style&gt;

    &lt;!-- *********************popwindow样式下拉菜单************************* --&gt;<br />
    &lt;!-- 自定义loading dialog：列表对话框 --&gt;<br />
    &lt;style name="dialogutil_list_style" parent="@android:style/Theme.Dialog"&gt;<br />
        &lt;!-- 边框 --&gt;<br />
        &lt;item name="android:windowFrame"&gt;@null&lt;/item&gt;<br />
        &lt;!-- 是否显示title --&gt;<br />
        &lt;item name="android:windowNoTitle"&gt;true&lt;/item&gt;<br />
        &lt;!-- 是否浮现在activity之上 --&gt;<br />
        &lt;item name="android:windowIsFloating"&gt;true&lt;/item&gt;<br />
        &lt;!-- 设置dialog的背景：#00000000透明色 --&gt;<br />
        &lt;item name="android:windowBackground"&gt;@android:color/transparent&lt;/item&gt;<br />
        &lt;!-- 半透明 --&gt;<br />
        &lt;item name="android:windowIsTranslucent"&gt;false&lt;/item&gt;<br />
        &lt;!-- 背景变灰：整个屏幕变灰，配合setCanceledOnTouchOutside(false) --&gt;<br />
        &lt;item name="android:backgroundDimEnabled"&gt;true&lt;/item&gt;<br />
        &lt;!-- 边距 --&gt;<br />
        &lt;item name="android:paddingLeft"&gt;20dp&lt;/item&gt;<br />
        &lt;item name="android:paddingRight"&gt;20dp&lt;/item&gt;<br />
    &lt;/style&gt;

&lt;/resources&gt;</pre>
</div>
<h4>将spinner包中的文件复制到项目中</h4>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/93830/201806/93830-20180606153719052-1333991991.png" /></p>
<h4>将bean包中的SpinnearBean复制到项目中。</h4>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/93830/201806/93830-20180606154213784-1784813738.png" /></p>
<p>至此，SpinnerViewPop集成到项目中了。</p>
<h3>三、使用方法</h3>
<h4>在Activity布局文件中引用SpinnerViewPop布局类【注意：需要重新引用SpinnerViewPop类的完整路径】</h4>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;LinearLayout<br />
    xmlns:android="http://schemas.android.com/apk/res/android"<br />
    xmlns:tools="http://schemas.android.com/tools"<br />
    android:id="@+id/activity_main"<br />
    android:layout_width="match_parent"<br />
    android:layout_height="match_parent"<br />
    android:paddingBottom="@dimen/activity_vertical_margin"<br />
    android:paddingLeft="@dimen/activity_horizontal_margin"<br />
    android:paddingRight="@dimen/activity_horizontal_margin"<br />
    android:paddingTop="@dimen/activity_vertical_margin"<br />
    android:orientation="vertical"<br />
    tools:context="com.why.project.spinnerviewpopdemo.MainActivity"&gt;

    &lt;!-- 列表弹出框（禁用的） --&gt;<br />
    &lt;com.why.project.spinnerviewpopdemo.views.spinner.SpinnerViewPop<br />
        android:id="@+id/spinnerView_pop0"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="@dimen/spinnerpop_height"<br />
        android:background="@drawable/spinnerview_pop_box_bg_drawable"<br />
        android:layout_margin="10dp"<br />
        /&gt;

    &lt;!-- 列表弹出框（popwindow样式） --&gt;<br />
    &lt;com.why.project.spinnerviewpopdemo.views.spinner.SpinnerViewPop<br />
        android:id="@+id/spinnerView_pop1"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="@dimen/spinnerpop_height"<br />
        android:background="@drawable/spinnerview_pop_box_bg_drawable"<br />
        android:layout_margin="10dp"<br />
        /&gt;

    &lt;!-- 列表弹出框（popwindow样式含背景色） --&gt;<br />
    &lt;com.why.project.spinnerviewpopdemo.views.spinner.SpinnerViewPop<br />
        android:id="@+id/spinnerView_pop2"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="@dimen/spinnerpop_height"<br />
        android:background="@drawable/spinnerview_pop_box_bg_drawable"<br />
        android:layout_margin="10dp"<br />
        /&gt;

    &lt;!-- 列表弹出框（对话框样式【单选】） --&gt;<br />
    &lt;com.why.project.spinnerviewpopdemo.views.spinner.SpinnerViewPop<br />
        android:id="@+id/spinnerView_pop3"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="@dimen/spinnerpop_height"<br />
        android:background="@drawable/spinnerview_pop_box_bg_drawable"<br />
        android:layout_margin="10dp"<br />
        /&gt;

    &lt;!-- 列表弹出框（对话框样式【多选】） --&gt;<br />
    &lt;com.why.project.spinnerviewpopdemo.views.spinner.SpinnerViewMultiDialog<br />
        android:id="@+id/spinnerView_pop4"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="@dimen/spinnerpop_height"<br />
        android:background="@drawable/spinnerview_pop_box_bg_drawable"<br />
        android:layout_margin="10dp"<br />
        /&gt;

    &lt;TextView<br />
        android:id="@+id/tv_show"<br />
        android:layout_width="wrap_content"<br />
        android:layout_height="wrap_content"<br />
        android:text="显示下拉菜单选中的内容"/&gt;

&lt;/LinearLayout&gt;</pre>
</div>
<h4>在Activity中使用如下：</h4>
<div>
<pre class="prettyprint linenums">package com.why.project.spinnerviewpopdemo;

import android.content.Context;<br />
import android.os.Bundle;<br />
import android.support.v7.app.AppCompatActivity;<br />
import android.widget.TextView;<br />
import android.widget.Toast;

import com.why.project.spinnerviewpopdemo.bean.SpinnearBean;<br />
import com.why.project.spinnerviewpopdemo.views.spinner.listener.OnSpinnerClickListener;<br />
import com.why.project.spinnerviewpopdemo.views.spinner.listener.OnSpinnerConfirmClickListener;<br />
import com.why.project.spinnerviewpopdemo.views.spinner.listener.OnSpinnerItemClickListener;<br />
import com.why.project.spinnerviewpopdemo.views.spinner.SpinnerViewMultiDialog;<br />
import com.why.project.spinnerviewpopdemo.views.spinner.SpinnerViewPop;

import org.json.JSONArray;<br />
import org.json.JSONObject;

import java.io.ByteArrayOutputStream;<br />
import java.io.InputStream;<br />
import java.util.ArrayList;

import static com.why.project.spinnerviewpopdemo.R.id.spinnerView_pop0;<br />
import static com.why.project.spinnerviewpopdemo.R.id.spinnerView_pop1;<br />
import static com.why.project.spinnerviewpopdemo.R.id.spinnerView_pop2;<br />
import static com.why.project.spinnerviewpopdemo.R.id.spinnerView_pop3;

public class MainActivity extends AppCompatActivity {

    private SpinnerViewPop spinnerView_notEditable;

    private SpinnerViewPop spinnerView_pop;<br />
    /**下拉菜单列表集合*/<br />
    private ArrayList&lt;SpinnearBean&gt; mSpinner1List;

    private SpinnerViewPop spinnerView_pop_bgcolor;<br />
    /**下拉菜单列表集合*/<br />
    private ArrayList&lt;SpinnearBean&gt; mSpinner2List;

    private SpinnerViewPop spinnerView_radioDialog;<br />
    /**下拉菜单列表集合*/<br />
    private ArrayList&lt;SpinnearBean&gt; mSpinner3List;

    private SpinnerViewMultiDialog spinnerView_multDialog;<br />
    /**下拉菜单列表集合*/<br />
    private ArrayList&lt;SpinnearBean&gt; mSpinner4List;

    private TextView tv_show;

    @Override<br />
    protected void onCreate(Bundle savedInstanceState) {<br />
        super.onCreate(savedInstanceState);<br />
        setContentView(R.layout.activity_main);

        initViews();<br />
        initDatas();<br />
        initEvents();<br />
    }

    private void initViews() {

        spinnerView_notEditable = (SpinnerViewPop) findViewById(spinnerView_pop0);<br />
        spinnerView_notEditable.setEditable(false);//禁用下拉菜单区域

        spinnerView_pop = (SpinnerViewPop) findViewById(spinnerView_pop1);<br />
        spinnerView_pop.setHandedPopup(true);//实现点击下拉菜单区域触发事件，一般用来隐藏软键盘，或者网络请求，最后手动弹出下拉菜单

        spinnerView_pop_bgcolor = (SpinnerViewPop) findViewById(spinnerView_pop2);

        spinnerView_radioDialog = (SpinnerViewPop) findViewById(spinnerView_pop3);<br />
        spinnerView_radioDialog.setSpinnerType(SpinnerViewPop.TYPE_DIALOG);//设置对话框样式，默认为popwindow样式

        spinnerView_multDialog = (SpinnerViewMultiDialog) findViewById(R.id.spinnerView_pop4);

        tv_show = (TextView) findViewById(R.id.tv_show);

    }

    private void initDatas() {<br />
        /*==============================普通下拉菜单列表项=========================================*/<br />
        mSpinner1List = new ArrayList&lt;SpinnearBean&gt;();<br />
        //模拟获取数据集合<br />
        try{<br />
            mSpinner1List = parseJsonArray("spinners.txt");<br />
        }catch (Exception e) {<br />
            e.printStackTrace();<br />
        }<br />
        //设置下拉菜单显示的列表项文本<br />
        if (mSpinner1List != null &amp;&amp; mSpinner1List.size() &gt; 0){<br />
            spinnerView_pop.setData(mSpinner1List);//设置下拉菜单列表集合源<br />
            spinnerView_pop.setSelectedIndexAndText(0);//更改下拉菜单选中的列表项下标值<br />
        }<br />
        /*==============================下拉菜单列表项带有背景颜色=========================================*/<br />
        mSpinner2List = new ArrayList&lt;SpinnearBean&gt;();<br />
        //模拟获取数据集合<br />
        try{<br />
            mSpinner2List = parseJsonArray("spinners2.txt");<br />
        }catch (Exception e) {<br />
            e.printStackTrace();<br />
        }<br />
        //设置下拉菜单显示的列表项文本<br />
        if (mSpinner2List != null &amp;&amp; mSpinner2List.size() &gt; 0){<br />
            spinnerView_pop_bgcolor.setData(mSpinner2List);//设置下拉菜单列表集合源<br />
            spinnerView_pop_bgcolor.setSelectedIndexAndText(0);//更改下拉菜单选中的列表项下标值<br />
        }

        /*==============================下拉菜单列表项单选对话框=========================================*/<br />
        mSpinner3List = new ArrayList&lt;SpinnearBean&gt;();<br />
        //模拟获取数据集合<br />
        try{<br />
            mSpinner3List = parseJsonArray("spinners3.txt");<br />
        }catch (Exception e) {<br />
            e.printStackTrace();<br />
        }<br />
        //设置下拉菜单显示的列表项文本<br />
        if (mSpinner3List != null &amp;&amp; mSpinner3List.size() &gt; 0){<br />
            spinnerView_radioDialog.setData(mSpinner3List);//设置下拉菜单列表集合源<br />
            spinnerView_radioDialog.setSelectedIndexAndText(0);//更改下拉菜单选中的列表项下标值<br />
        }

        /*==============================下拉菜单列表项多选对话框=========================================*/<br />
        mSpinner4List = new ArrayList&lt;SpinnearBean&gt;();<br />
        //模拟获取数据集合<br />
        try{<br />
            mSpinner4List = parseJsonArray("spinners4.txt");<br />
        }catch (Exception e) {<br />
            e.printStackTrace();<br />
        }<br />
        //设置下拉菜单显示的列表项文本<br />
        if (mSpinner4List != null &amp;&amp; mSpinner4List.size() &gt; 0){<br />
            spinnerView_multDialog.setData(mSpinner4List);//设置下拉菜单列表集合源<br />
            spinnerView_multDialog.setHint("选择你的爱好");<br />
        }

    }

    private void initEvents() {

        //下拉菜单区域的点击事件监听<br />
        spinnerView_pop.setOnSpinnerClickListener(new OnSpinnerClickListener() {<br />
            @Override<br />
            public void OnFinished() {<br />
                //KeyboardUtil.hideKeyboard(MainActivity.this);//隐藏软键盘<br />
                spinnerView_pop.PopupListDialog();<br />
            }<br />
        });<br />
        //下拉菜单列表的列表项的点击事件监听<br />
        spinnerView_pop.setOnSpinnerItemClickListener(new OnSpinnerItemClickListener() {<br />
            @Override<br />
            public void OnFinished(int position) {<br />
                tv_show.setText(mSpinner1List.get(position).getParaName() + ":" + mSpinner1List.get(position).getParaValue());<br />
                StringBuffer str = new StringBuffer();<br />
                for(int i=0;i&lt;mSpinner1List.size();i++){<br />
                    str.append(mSpinner1List.get(i).getParaName() + ":" + mSpinner1List.get(i).isSelectedState() + "\n");<br />
                }<br />
                tv_show.setText(tv_show.getText() + "\n=====================\n" + str);<br />
            }<br />
        });

        //下拉菜单列表的列表项的点击事件监听<br />
        spinnerView_pop_bgcolor.setOnSpinnerItemClickListener(new OnSpinnerItemClickListener() {<br />
            @Override<br />
            public void OnFinished(int position) {<br />
                tv_show.setText(mSpinner2List.get(position).getParaName() + ":" + mSpinner2List.get(position).getParaValue());<br />
                StringBuffer str = new StringBuffer();<br />
                for(int i=0;i&lt;mSpinner2List.size();i++){<br />
                    str.append(mSpinner2List.get(i).getParaName() + ":" + mSpinner2List.get(i).isSelectedState() + "\n");<br />
                }<br />
                tv_show.setText(tv_show.getText() + "\n=====================\n" + str);<br />
            }<br />
        });

        //下拉菜单列表的列表项的点击事件监听<br />
        spinnerView_radioDialog.setOnSpinnerItemClickListener(new OnSpinnerItemClickListener() {<br />
            @Override<br />
            public void OnFinished(int position) {<br />
                tv_show.setText(mSpinner3List.get(position).getParaName() + ":" + mSpinner3List.get(position).getParaValue());<br />
                StringBuffer str = new StringBuffer();<br />
                for(int i=0;i&lt;mSpinner3List.size();i++){<br />
                    str.append(mSpinner3List.get(i).getParaName() + ":" + mSpinner3List.get(i).isSelectedState() + "\n");<br />
                }<br />
                tv_show.setText(tv_show.getText() + "\n=====================\n" + str);<br />
            }<br />
        });

        //下拉菜单列表的列表项的点击事件监听<br />
        spinnerView_multDialog.setOnSpinnerConfirmClickListener(new OnSpinnerConfirmClickListener() {<br />
            @Override<br />
            public void OnConfirmed(ArrayList&lt;Boolean&gt; selecteIndexList) {<br />
                StringBuffer str1 = new StringBuffer();<br />
                for(int i=0;i&lt;selecteIndexList.size();i++){<br />
                    if(selecteIndexList.get(i)){//如果为true,则执行下面的代码<br />
                        str1.append(mSpinner4List.get(i).getParaName() + ":" + mSpinner4List.get(i).getParaValue() + "\n");<br />
                    }<br />
                }<br />
                tv_show.setText(str1);

                StringBuffer str = new StringBuffer();<br />
                for(int i=0;i&lt;mSpinner4List.size();i++){<br />
                    str.append(mSpinner4List.get(i).getParaName() + ":" + mSpinner4List.get(i).isSelectedState() + "\n");<br />
                }<br />
                tv_show.setText(tv_show.getText() + "=====================\n" + str);<br />
            }<br />
        });<br />
    }

    /*===========读取assets目录下的js字符串文件（js数组和js对象），然后生成List集合===========*/<br />
    public static final String LISTROOTNODE = "spinnerList";<br />
    public static final String KEY_LISTITEM_NAME = "paraName";<br />
    public static final String KEY_LISTITEM_VALUE = "paraValue";<br />
    public static final String KEY_LISTITEM_CHECKCOLOR = "checkColor";

    /**<br />
     * 解析JSON文件的简单数组<br />
     */<br />
    private ArrayList&lt;SpinnearBean&gt; parseJsonArray(String fileName) throws Exception{

        ArrayList&lt;SpinnearBean&gt; itemsList = new ArrayList&lt;SpinnearBean&gt;();

        String jsonStr = getStringFromAssert(MainActivity.this, fileName);<br />
        if(jsonStr.equals("")){<br />
            return null;<br />
        }<br />
        JSONObject allData = new JSONObject(jsonStr);  //全部内容变为一个项<br />
        JSONArray jsonArr = allData.getJSONArray(LISTROOTNODE); //取出数组<br />
        for(int x = 0;x&lt;jsonArr.length();x++){<br />
            SpinnearBean model = new SpinnearBean();<br />
            JSONObject jsonobj = jsonArr.getJSONObject(x);<br />
            model.setParaName(jsonobj.getString(KEY_LISTITEM_NAME));<br />
            model.setParaValue(jsonobj.getString(KEY_LISTITEM_VALUE));<br />
            if(jsonobj.has(KEY_LISTITEM_CHECKCOLOR)){<br />
                model.setCheckColor(jsonobj.getString(KEY_LISTITEM_CHECKCOLOR));<br />
            }<br />
            model.setSelectedState(false);<br />
            itemsList.add(model);<br />
            model = null;<br />
        }<br />
        return itemsList;<br />
    }

    /**<br />
     * 访问assets目录下的资源文件，获取文件中的字符串<br />
     * @param filePath - 文件的相对路径，例如："listdata.txt"或者"/www/listdata.txt"<br />
     * @return 内容字符串<br />
     * */<br />
    public String getStringFromAssert(Context mContext, String filePath) {

        String content = ""; // 结果字符串<br />
        try {<br />
            InputStream is = mContext.getResources().getAssets().open(filePath);// 打开文件<br />
            int ch = 0;<br />
            ByteArrayOutputStream out = new ByteArrayOutputStream(); // 实现了一个输出流<br />
            while ((ch = is.read()) != -1) {<br />
                out.write(ch); // 将指定的字节写入此 byte 数组输出流<br />
            }<br />
            byte[] buff = out.toByteArray();// 以 byte 数组的形式返回此输出流的当前内容<br />
            out.close(); // 关闭流<br />
            is.close(); // 关闭流<br />
            content = new String(buff, "UTF-8"); // 设置字符串编码<br />
        } catch (Exception e) {<br />
            Toast.makeText(mContext, "对不起，没有找到指定文件！", Toast.LENGTH_SHORT)<br />
                    .show();<br />
        }<br />
        return content;<br />
    }<br />
}</pre>
</div>
<h2>混淆配置</h2>
<p>无</p>
<h2>参考资料</h2>
<p>暂时空缺</p>
<h2>项目demo下载地址</h2>
<p><a href="https://github.com/haiyuKing/SpinnerViewPopDemo" rel="external nofollow noreferrer">https://github.com/haiyuKing/SpinnerViewPopDemo</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pwrkk8.html">我的java后端书架</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvndl19.html">nginx&period;conf的events，http段一般固定配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgeom8.html">拿什么来拯救你，我的table</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mx2k9.html">小课堂week14 Google软件测试之道</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yd2p0q.html">DllImport属性详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wjz2q.html">ASP&period;NET Excel导入到SQL Server数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/950dl168.html">nodejs-基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey2xpj9.html">2017-06-23（chmod whoami chown）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkxrr08.html">linux 中 ping的回传值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zlkxj9.html">ansible的tags</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwo1d9.html">ssh连接所生成的known&lowbar;hosts出现的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjyzd09.html">Hive：解决Hive创建文件数过多的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5x7r7q.html">JS之鼠标改变img</a>
		</li>
						<li><a href="https://www.batexi.com/a/93px7rn8.html">BZOJ1009 GT考试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2n71z8.html">WIN10下使用Anaconda配置opencv、tensorflow、pygame并在pycharm中运用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2kp0j8.html">android中使用通知功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjddj7q.html">VS添加节点</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pd6er8.html">Entity  Framework  6  和  MVC5</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnyel7q.html">Android Intent参数传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmjywd9.html">golang的beego框架开发时出现的问题纪录</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rg2gmm8.html">Prometheus运⾏框架介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjgjyr8.html">CSS操作笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/950e0o68.html">VMware12安装虚拟机教程、Ubuntu16&period;04安装教程（包括vmware tools的安装）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpejj69.html">handler&period;go</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge7jo08.html">【bzoj 4176】 Lucas的数论 莫比乌斯反演（杜教筛）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpem239.html">Java NIO  概览</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpydxvq.html">测试修改hosts文件py小工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m3ero8.html">微服务架构 - 搭建docker本地镜像仓库并提供权限校验及UI界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m3elj8.html">&lbrack;dotnet&rsqb; 封装一个同时支持密码&sol;安全密钥认证的SFTP下载器，简单易用。</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpevv79.html">Python2与Python3字符编码的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
